Index: stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/AllArchitectureAlteringOperatorsTest.cs
===================================================================
--- stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/AllArchitectureAlteringOperatorsTest.cs	(revision 9503)
+++ stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/AllArchitectureAlteringOperatorsTest.cs	(revision 9885)
@@ -24,9 +24,8 @@
 using System.Diagnostics;
 using HeuristicLab.Data;
-using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
 using HeuristicLab.Random;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding_34.Tests {
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Tests {
   [TestClass]
   public class AllArchitectureAlteringOperatorsTest {
@@ -35,21 +34,9 @@
     private const int MAX_TREE_LENGTH = 100;
     private const int MAX_TREE_DEPTH = 10;
-    private TestContext testContextInstance;
 
-    /// <summary>
-    ///Gets or sets the test context which provides
-    ///information about and functionality for the current test run.
-    ///</summary>
-    public TestContext TestContext {
-      get {
-        return testContextInstance;
-      }
-      set {
-        testContextInstance = value;
-      }
-    }
-
-    [TestMethod()]
+    [TestMethod]
     [Timeout(3600000)]
+    [TestCategory("Encodings.SymbolicExpressionTree")]
+    [TestProperty("Time", "long")]
     public void AllArchitectureAlteringOperatorsDistributionTest() {
       var trees = new List<ISymbolicExpressionTree>();
Index: stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/ArgumentCreaterTest.cs
===================================================================
--- stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/ArgumentCreaterTest.cs	(revision 9503)
+++ stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/ArgumentCreaterTest.cs	(revision 9885)
@@ -27,5 +27,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding_34.Tests {
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Tests {
   [TestClass]
   public class ArgumentCreaterTest {
@@ -33,20 +33,8 @@
     private const int MAX_TREE_LENGTH = 100;
     private const int MAX_TREE_DEPTH = 10;
-    private TestContext testContextInstance;
 
-    /// <summary>
-    ///Gets or sets the test context which provides
-    ///information about and functionality for the current test run.
-    ///</summary>
-    public TestContext TestContext {
-      get {
-        return testContextInstance;
-      }
-      set {
-        testContextInstance = value;
-      }
-    }
-
-    [TestMethod()]
+    [TestMethod]
+    [TestCategory("Encodings.SymbolicExpressionTree")]
+    [TestProperty("Time", "long")]
     public void ArgumentCreaterDistributionsTest() {
       var trees = new List<ISymbolicExpressionTree>();
Index: stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/ArgumentDeleterTest.cs
===================================================================
--- stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/ArgumentDeleterTest.cs	(revision 9503)
+++ stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/ArgumentDeleterTest.cs	(revision 9885)
@@ -27,5 +27,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding_34.Tests {
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Tests {
   [TestClass]
   public class ArgumentDeleterTest {
@@ -33,20 +33,8 @@
     private const int MAX_TREE_LENGTH = 100;
     private const int MAX_TREE_DEPTH = 10;
-    private TestContext testContextInstance;
 
-    /// <summary>
-    ///Gets or sets the test context which provides
-    ///information about and functionality for the current test run.
-    ///</summary>
-    public TestContext TestContext {
-      get {
-        return testContextInstance;
-      }
-      set {
-        testContextInstance = value;
-      }
-    }
-
-    [TestMethod()]
+    [TestMethod]
+    [TestCategory("Encodings.SymbolicExpressionTree")]
+    [TestProperty("Time", "long")]
     public void ArgumentDeleterDistributionsTest() {
       var trees = new List<ISymbolicExpressionTree>();
Index: stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/ArgumentDuplicaterTest.cs
===================================================================
--- stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/ArgumentDuplicaterTest.cs	(revision 9503)
+++ stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/ArgumentDuplicaterTest.cs	(revision 9885)
@@ -27,5 +27,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding_34.Tests {
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Tests {
   [TestClass]
   public class ArgumentDuplicaterTest {
@@ -33,20 +33,8 @@
     private const int MAX_TREE_LENGTH = 100;
     private const int MAX_TREE_DEPTH = 10;
-    private TestContext testContextInstance;
 
-    /// <summary>
-    ///Gets or sets the test context which provides
-    ///information about and functionality for the current test run.
-    ///</summary>
-    public TestContext TestContext {
-      get {
-        return testContextInstance;
-      }
-      set {
-        testContextInstance = value;
-      }
-    }
-
-    [TestMethod()]
+    [TestMethod]
+    [TestCategory("Encodings.SymbolicExpressionTree")]
+    [TestProperty("Time", "long")]
     public void ArgumentDuplicaterDistributionsTest() {
       var trees = new List<ISymbolicExpressionTree>();
Index: stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/ChangeNodeTypeManipulationTest.cs
===================================================================
--- stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/ChangeNodeTypeManipulationTest.cs	(revision 9503)
+++ stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/ChangeNodeTypeManipulationTest.cs	(revision 9885)
@@ -26,5 +26,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding_34.Tests {
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Tests {
   [TestClass]
   public class ChangeNodeTypeManipulationTest {
@@ -32,20 +32,8 @@
     private const int MAX_TREE_LENGTH = 100;
     private const int MAX_TREE_DEPTH = 10;
-    private TestContext testContextInstance;
 
-    /// <summary>
-    ///Gets or sets the test context which provides
-    ///information about and functionality for the current test run.
-    ///</summary>
-    public TestContext TestContext {
-      get {
-        return testContextInstance;
-      }
-      set {
-        testContextInstance = value;
-      }
-    }
-
-    [TestMethod()]
+    [TestMethod]
+    [TestCategory("Encodings.SymbolicExpressionTree")]
+    [TestProperty("Time", "medium")]
     public void ChangeNodeTypeManipulationDistributionsTest() {
       SymbolicExpressionTreeStringFormatter formatter = new SymbolicExpressionTreeStringFormatter();
Index: stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/FullTreeCreatorTest.cs
===================================================================
--- stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/FullTreeCreatorTest.cs	(revision 9503)
+++ stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/FullTreeCreatorTest.cs	(revision 9885)
@@ -27,5 +27,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding_34.Tests {
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Tests {
   [TestClass]
   public class FullTreeCreatorTest {
@@ -33,20 +33,8 @@
     private const int MAX_TREE_DEPTH = 9;
     private const int MAX_TREE_LENGTH = 256;
-    private TestContext testContextInstance;
 
-    /// <summary>
-    ///Gets or sets the test context which provides
-    ///information about and functionality for the current test run.
-    ///</summary>
-    public TestContext TestContext {
-      get {
-        return testContextInstance;
-      }
-      set {
-        testContextInstance = value;
-      }
-    }
-
-    [TestMethod()]
+    [TestMethod]
+    [TestCategory("Encodings.SymbolicExpressionTree")]
+    [TestProperty("Time", "long")]
     public void FullTreeCreatorDistributionsTest() {
       var randomTrees = new List<ISymbolicExpressionTree>();
Index: stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/Grammars.cs
===================================================================
--- stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/Grammars.cs	(revision 9503)
+++ stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/Grammars.cs	(revision 9885)
@@ -24,5 +24,5 @@
 using HeuristicLab.Problems.DataAnalysis.Symbolic;
 
-namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding_34.Tests {
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Tests {
   public static class Grammars {
     public static ISymbolicExpressionGrammar CreateSimpleArithmeticGrammar() {
Index: stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/GrowTreeCreatorTest.cs
===================================================================
--- stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/GrowTreeCreatorTest.cs	(revision 9503)
+++ stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/GrowTreeCreatorTest.cs	(revision 9885)
@@ -27,5 +27,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding_34.Tests {
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Tests {
   [TestClass]
   public class GrowTreeCreatorTest {
@@ -33,20 +33,8 @@
     private const int MAX_TREE_DEPTH = 10;
     private const int MAX_TREE_LENGTH = 50;
-    private TestContext testContextInstance;
 
-    /// <summary>
-    ///Gets or sets the test context which provides
-    ///information about and functionality for the current test run.
-    ///</summary>
-    public TestContext TestContext {
-      get {
-        return testContextInstance;
-      }
-      set {
-        testContextInstance = value;
-      }
-    }
-
-    [TestMethod()]
+    [TestMethod]
+    [TestCategory("Encodings.SymbolicExpressionTree")]
+    [TestProperty("Time", "long")]
     public void GrowTreeCreatorDistributionsTest() {
       var randomTrees = new List<ISymbolicExpressionTree>();
Index: stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/ProbabilisticTreeCreaterTest.cs
===================================================================
--- stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/ProbabilisticTreeCreaterTest.cs	(revision 9503)
+++ stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/ProbabilisticTreeCreaterTest.cs	(revision 9885)
@@ -27,5 +27,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding_34.Tests {
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Tests {
   [TestClass]
   public class ProbabilisticTreeCreaterTest {
@@ -33,20 +33,8 @@
     private const int MAX_TREE_LENGTH = 100;
     private const int MAX_TREE_DEPTH = 10;
-    private TestContext testContextInstance;
-
-    /// <summary>
-    ///Gets or sets the test context which provides
-    ///information about and functionality for the current test run.
-    ///</summary>
-    public TestContext TestContext {
-      get {
-        return testContextInstance;
-      }
-      set {
-        testContextInstance = value;
-      }
-    }
 
     [TestMethod()]
+    [TestCategory("Encodings.SymbolicExpressionTree")]
+    [TestProperty("Time", "long")]
     public void ProbabilisticTreeCreaterDistributionsTest() {
       var randomTrees = new List<ISymbolicExpressionTree>();
@@ -84,4 +72,6 @@
 
     [TestMethod]
+    [TestCategory("Encodings.SymbolicExpressionTree")]
+    [TestProperty("Time", "short")]
     public void ProbabilisticTreeCreatorSpecificTreeSizesTest() {
       var trees = new List<ISymbolicExpressionTree>();
Index: stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/ReplaceBranchManipulationTest.cs
===================================================================
--- stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/ReplaceBranchManipulationTest.cs	(revision 9503)
+++ stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/ReplaceBranchManipulationTest.cs	(revision 9885)
@@ -26,5 +26,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding_34.Tests {
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Tests {
   [TestClass]
   public class ReplaceBranchManipulationTest {
@@ -32,20 +32,8 @@
     private const int MAX_TREE_LENGTH = 100;
     private const int MAX_TREE_DEPTH = 10;
-    private TestContext testContextInstance;
 
-    /// <summary>
-    ///Gets or sets the test context which provides
-    ///information about and functionality for the current test run.
-    ///</summary>
-    public TestContext TestContext {
-      get {
-        return testContextInstance;
-      }
-      set {
-        testContextInstance = value;
-      }
-    }
-
-    [TestMethod()]
+    [TestMethod]
+    [TestCategory("Encodings.SymbolicExpressionTree")]
+    [TestProperty("Time", "long")]
     public void ReplaceBranchManipulationDistributionsTest() {
       SymbolicExpressionTreeStringFormatter formatter = new SymbolicExpressionTreeStringFormatter();
Index: stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/SubroutineCreaterTest.cs
===================================================================
--- stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/SubroutineCreaterTest.cs	(revision 9503)
+++ stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/SubroutineCreaterTest.cs	(revision 9885)
@@ -22,9 +22,8 @@
 using System;
 using System.Collections.Generic;
-using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
 using HeuristicLab.Random;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding_34.Tests {
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Tests {
   [TestClass]
   public class SubroutineCreaterTest {
@@ -32,20 +31,8 @@
     private const int MAX_TREE_LENGTH = 100;
     private const int MAX_TREE_DEPTH = 10;
-    private TestContext testContextInstance;
 
-    /// <summary>
-    ///Gets or sets the test context which provides
-    ///information about and functionality for the current test run.
-    ///</summary>
-    public TestContext TestContext {
-      get {
-        return testContextInstance;
-      }
-      set {
-        testContextInstance = value;
-      }
-    }
-
-    [TestMethod()]
+    [TestMethod]
+    [TestCategory("Encodings.SymbolicExpressionTree")]
+    [TestProperty("Time", "long")]
     public void SubroutineCreaterDistributionsTest() {
       var trees = new List<ISymbolicExpressionTree>();
Index: stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/SubroutineDeleterTest.cs
===================================================================
--- stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/SubroutineDeleterTest.cs	(revision 9503)
+++ stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/SubroutineDeleterTest.cs	(revision 9885)
@@ -23,9 +23,8 @@
 using System.Collections.Generic;
 using System.Linq;
-using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
 using HeuristicLab.Random;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding_34.Tests {
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Tests {
   [TestClass]
   public class SubroutineDeleterTest {
@@ -33,20 +32,8 @@
     private const int MAX_TREE_LENGTH = 100;
     private const int MAX_TREE_DEPTH = 10;
-    private TestContext testContextInstance;
 
-    /// <summary>
-    ///Gets or sets the test context which provides
-    ///information about and functionality for the current test run.
-    ///</summary>
-    public TestContext TestContext {
-      get {
-        return testContextInstance;
-      }
-      set {
-        testContextInstance = value;
-      }
-    }
-
-    [TestMethod()]
+    [TestMethod]
+    [TestCategory("Encodings.SymbolicExpressionTree")]
+    [TestProperty("Time", "long")]
     public void SubroutineDeleterDistributionsTest() {
       var trees = new List<ISymbolicExpressionTree>();
Index: stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/SubroutineDuplicaterTest.cs
===================================================================
--- stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/SubroutineDuplicaterTest.cs	(revision 9503)
+++ stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/SubroutineDuplicaterTest.cs	(revision 9885)
@@ -23,9 +23,8 @@
 using System.Collections.Generic;
 using System.Linq;
-using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
 using HeuristicLab.Random;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding_34.Tests {
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Tests {
   [TestClass]
   public class SubroutineDuplicaterTest {
@@ -33,20 +32,8 @@
     private const int MAX_TREE_LENGTH = 100;
     private const int MAX_TREE_DEPTH = 10;
-    private TestContext testContextInstance;
 
-    /// <summary>
-    ///Gets or sets the test context which provides
-    ///information about and functionality for the current test run.
-    ///</summary>
-    public TestContext TestContext {
-      get {
-        return testContextInstance;
-      }
-      set {
-        testContextInstance = value;
-      }
-    }
-
-    [TestMethod()]
+    [TestMethod]
+    [TestCategory("Encodings.SymbolicExpressionTree")]
+    [TestProperty("Time", "long")]
     public void SubroutineDuplicaterDistributionsTest() {
       var trees = new List<ISymbolicExpressionTree>();
Index: stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/SubtreeCrossoverTest.cs
===================================================================
--- stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/SubtreeCrossoverTest.cs	(revision 9503)
+++ stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/SubtreeCrossoverTest.cs	(revision 9885)
@@ -23,28 +23,15 @@
 using System.Collections.Generic;
 using System.Diagnostics;
-using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
 using HeuristicLab.Random;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding_34.Tests {
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Tests {
   [TestClass]
   public class SubtreeCrossoverTest {
     private const int POPULATION_SIZE = 1000;
-    private TestContext testContextInstance;
 
-    /// <summary>
-    ///Gets or sets the test context which provides
-    ///information about and functionality for the current test run.
-    ///</summary>
-    public TestContext TestContext {
-      get {
-        return testContextInstance;
-      }
-      set {
-        testContextInstance = value;
-      }
-    }
-
-    [TestMethod()]
+    [TestMethod]
+    [TestCategory("Encodings.SymbolicExpressionTree")]
+    [TestProperty("Time", "long")]
     public void SubtreeCrossoverDistributionsTest() {
       int generations = 5;
Index: stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/Util.cs
===================================================================
--- stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/Util.cs	(revision 9503)
+++ stable/HeuristicLab.Tests/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4/Util.cs	(revision 9885)
@@ -27,5 +27,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding_34.Tests {
+namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Tests {
   public static class Util {
     public static string GetSizeDistributionString(IList<ISymbolicExpressionTree> trees, int maxTreeLength, int binSize) {