Index: /stable/HeuristicLab 3.3 Tests.vsmdi
===================================================================
--- /stable/HeuristicLab 3.3 Tests.vsmdi	(revision 9885)
+++ /stable/HeuristicLab 3.3 Tests.vsmdi	(revision 9886)
@@ -13,8 +13,8 @@
       <TestLink id="bc68e399-f34c-453c-97cf-8944ad7322bb" name="CreateEsGriewankSampleTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
       <TestLink id="9ae4cc78-7549-dc4a-739c-e2823b7436e5" name="RunGpArtificialAntSampleTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
-      <TestLink id="c8cecb75-207d-f575-c608-19dcc1793616" name="RunPsoSchwefelSampleTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
       <TestLink id="e9c9efed-9a10-0c35-986e-2fc14453bd37" name="CreateScatterSearchVRPSampleTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
       <TestLink id="8dd6801d-950c-d10c-e409-d49b7dd31c52" name="CreatePsoSchwefelSampleTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
       <TestLink id="2c123c71-84a9-cbda-33d0-cdc7eddc5c28" name="RunIslandGaTspSampleTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
+      <TestLink id="04563734-217f-864b-fe15-b97f93e0d476" name="CreateRAPGASchedulingSampleTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
       <TestLink id="1d01a322-1e25-6da6-0c91-90b8a1368ca4" name="CreateVnsTspSampleTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
       <TestLink id="76ece8b3-30dc-0ee5-c096-33480bbd1683" name="CreateIslandGaTspSampleTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
@@ -35,5 +35,5 @@
       <TestLink id="34f3e502-22f0-ecd3-8811-899943d7a5ce" name="RunTabuSearchVRPSampleTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
       <TestLink id="ba3a6d8b-65f3-1464-bbba-4f1f3ba5721e" name="RunTabuSearchTspSampleTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
-      <TestLink id="04563734-217f-864b-fe15-b97f93e0d476" name="CreateRAPGASchedulingSampleTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
+      <TestLink id="c8cecb75-207d-f575-c608-19dcc1793616" name="RunPsoSchwefelSampleTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
     </TestLinks>
   </TestList>
@@ -57,15 +57,16 @@
     <Description>This should be run whenever a new plugin is added or a plugin dependency or an assembly reference is added, updated, or deleted.</Description>
     <TestLinks>
+      <TestLink id="ee3fccd7-766b-ab66-eb4d-f99fb11310a3" name="TestCloningConstructor" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
+      <TestLink id="5b2c47f1-9468-ac34-8edd-f59a7c139445" name="CheckReferenceAssembliesForPluginDependencies" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
+      <TestLink id="05841aed-16ec-a0b7-0688-45c1366b1cd3" name="NamedItemTestNameNotEmpty" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
+      <TestLink id="ebcbe255-075f-7ef2-c6e4-8c22202e1c7a" name="BuildTypeTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
       <TestLink id="715a0741-e8c1-ea5c-5a6f-fbbae30e95a8" name="InstantiateAllCreatables" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
+      <TestLink id="3df6f9a5-55f4-db76-f0c1-f49377067ea8" name="ContentViewAttributeTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
+      <TestLink id="cc872b4f-4e35-33c8-8289-5a4cf3cbbce6" name="TestToString" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
       <TestLink id="504d733a-e966-67b0-0ba8-3b4888281cf4" name="TestStorableConstructor" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
-      <TestLink id="cc872b4f-4e35-33c8-8289-5a4cf3cbbce6" name="TestToString" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
+      <TestLink id="55966e1d-fca8-fba9-a841-59c773f773c7" name="TestParameterVisibility" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
       <TestLink id="0ce573f2-91a8-3077-eecc-904f97bdb9c0" name="TestCloningAllDeepCloneables" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
-      <TestLink id="5b2c47f1-9468-ac34-8edd-f59a7c139445" name="CheckReferenceAssembliesForPluginDependencies" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
       <TestLink id="d97af6e5-d9b9-5659-4bed-f5dc07ae803c" name="CollectGASample" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
-      <TestLink id="ee3fccd7-766b-ab66-eb4d-f99fb11310a3" name="TestCloningConstructor" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
       <TestLink id="9c0cdbd0-5ad5-51ee-cae0-8fad5012ea71" name="IsSubTypeOfTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
-      <TestLink id="55966e1d-fca8-fba9-a841-59c773f773c7" name="TestParameterVisibility" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
-      <TestLink id="ebcbe255-075f-7ef2-c6e4-8c22202e1c7a" name="BuildTypeTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
-      <TestLink id="3df6f9a5-55f4-db76-f0c1-f49377067ea8" name="ContentViewAttributeTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
       <TestLink id="bf0dd0b1-2095-ee2b-0e5a-270d61f3e645" name="CheckPluginDependenciesForReferencedAssemblies" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
     </TestLinks>
Index: /stable/HeuristicLab.Analysis/3.3/DataVisualization/DataTable.cs
===================================================================
--- /stable/HeuristicLab.Analysis/3.3/DataVisualization/DataTable.cs	(revision 9885)
+++ /stable/HeuristicLab.Analysis/3.3/DataVisualization/DataTable.cs	(revision 9886)
@@ -91,4 +91,5 @@
     public DataTable()
       : base() {
+      Name = "DataTable";
       VisualProperties = new DataTableVisualProperties();
       Rows = new NamedItemCollection<DataRow>();
Index: /stable/HeuristicLab.Analysis/3.3/DataVisualization/ScatterPlotDataRow.cs
===================================================================
--- /stable/HeuristicLab.Analysis/3.3/DataVisualization/ScatterPlotDataRow.cs	(revision 9885)
+++ /stable/HeuristicLab.Analysis/3.3/DataVisualization/ScatterPlotDataRow.cs	(revision 9886)
@@ -78,4 +78,5 @@
     public ScatterPlotDataRow()
       : base() {
+      Name = "ScatterPlotDataRow";
       VisualProperties = new ScatterPlotDataRowVisualProperties();
       points = new ObservableList<Point2D<double>>();
Index: /stable/HeuristicLab.Clients.Hive/3.3/HiveTasks/HiveTask.cs
===================================================================
--- /stable/HeuristicLab.Clients.Hive/3.3/HiveTasks/HiveTask.cs	(revision 9885)
+++ /stable/HeuristicLab.Clients.Hive/3.3/HiveTasks/HiveTask.cs	(revision 9886)
@@ -172,5 +172,7 @@
     protected HiveTask(bool deserializing) { }
 
-    public HiveTask() {
+    public HiveTask()
+      : base() {
+      Name = "Hive Task";
       this.Task = new Task() { CoresNeeded = 1, MemoryNeeded = 128 };
       task.State = TaskState.Offline;
Index: /stable/HeuristicLab.Clients.Hive/3.3/Tasks/EngineTask.cs
===================================================================
--- /stable/HeuristicLab.Clients.Hive/3.3/Tasks/EngineTask.cs	(revision 9885)
+++ /stable/HeuristicLab.Clients.Hive/3.3/Tasks/EngineTask.cs	(revision 9886)
@@ -50,5 +50,4 @@
 
     #region constructors and cloning
-    public EngineTask() { }
     public EngineTask(IOperation initialOperation, IEngine engine) {
       this.initialOperation = initialOperation;
@@ -144,5 +143,5 @@
 
     public override string Name {
-      get { return Item != null ? Item.ToString() : null; }
+      get { return Item != null ? Item.ToString() : "Engine Task"; }
       set { throw new NotSupportedException(); }
     }
@@ -153,5 +152,5 @@
 
     public override string ItemName {
-      get { return "EngineTask"; }
+      get { return "Engine Task"; }
     }
   }
Index: /stable/HeuristicLab.Clients.Hive/3.3/Tasks/OptimizerTask.cs
===================================================================
--- /stable/HeuristicLab.Clients.Hive/3.3/Tasks/OptimizerTask.cs	(revision 9885)
+++ /stable/HeuristicLab.Clients.Hive/3.3/Tasks/OptimizerTask.cs	(revision 9886)
@@ -46,7 +46,5 @@
     }
 
-    public OptimizerTask() : base() { }
-    public OptimizerTask(IOptimizer optimizer)
-      : this() {
+    public OptimizerTask(IOptimizer optimizer) {
       this.Item = optimizer;
 
@@ -210,5 +208,5 @@
       get {
         if (Item == null)
-          return string.Empty;
+          return "Optimizer Task";
         else
           return Item.Name;
Index: /stable/HeuristicLab.Tests/HeuristicLab-3.3/NamedItemTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab-3.3/NamedItemTest.cs	(revision 9886)
+++ /stable/HeuristicLab.Tests/HeuristicLab-3.3/NamedItemTest.cs	(revision 9886)
@@ -0,0 +1,30 @@
+﻿using System.Linq;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.PluginInfrastructure;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+namespace HeuristicLab.Tests {
+  [TestClass]
+  public class NamedItemTest {
+    [ClassInitialize]
+    public static void MyClassInitialize(TestContext testContext) {
+      PluginLoader.Assemblies.Any();
+    }
+
+    [TestMethod]
+    [TestCategory("General")]
+    [TestCategory("Essential")]
+    [TestProperty("Time", "long")]
+    public void NamedItemTestNameNotEmpty() {
+      StringBuilder sb = new StringBuilder();
+      foreach (var namedItem in ApplicationManager.Manager.GetInstances<INamedItem>()) {
+        if (string.IsNullOrEmpty(namedItem.Name)) {
+          sb.AppendLine(string.Format("{0} does not have a name specified when created by the default ctor.", namedItem.GetType().GetPrettyName()));
+        }
+      }
+      Assert.IsTrue(sb.Length == 0, sb.ToString());
+    }
+  }
+}
Index: /stable/HeuristicLab.Tests/HeuristicLab.Tests.csproj
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 9885)
+++ /stable/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 9886)
@@ -342,4 +342,5 @@
     <Compile Include="HeuristicLab-3.3\CollectObjectGraphTest.cs" />
     <Compile Include="HeuristicLab-3.3\ContentViewTests.cs" />
+    <Compile Include="HeuristicLab-3.3\NamedItemTest.cs" />
     <Compile Include="HeuristicLab-3.3\ParameterVisibilityTest.cs" />
     <Compile Include="HeuristicLab-3.3\DeepCloneableCloningTest.cs" />